##############		Read me			##############
#In HSDC Pro ADC tab, Select AFE79xx_1x1RX_12410_RXC; Data Rate = 93M ---> To capture RXC channel
#An external 930MHz clock, 5dBm, must be given to the LMK through J14, LMK_CLK_IN

sysParams=AFE.systemParams
sysParams.__init__();sysParams.chipVersion=chipVersion

setupParams.skipFpga = 1 # setup FPGA (TSW14J56) using HSDC Pro 

##############		Top Level			##############
sysParams.FRef			= 465#256 #491.52
sysParams.FadcRx		= 2976
sysParams.FadcFb		= 2976
sysParams.Fdac			= 2976*3
sysParams.externalClockRx=False
sysParams.externalClockTx=False
													
##############		Digital Chain		##############

		#####	RX	#####
sysParams.rxEnable = [False,False,True,False]
sysParams.ddcFactorRx	=	[32]*4			#DDC decimation factor for RX A, B, C and D
##sysParams.numRxNCO		=	2
sysParams.rxNco0		= 	[[2000,2000],			#Band0, Band1 for RXA 
							[2000,2000],        	#Band0, Band1 for RXB 
							[2000,2000],        	#Band0, Band1 for RXC 
							[2000,2000]]        	#Band0, Band1 for RXD
##sysParams.numBandsRx 	= 	[1,1,1,1]
##sysParams.rxNco1		= 	[[5400,5400],			#Band0, Band1 for RXA 
##							[1643.5,1643.5],       	#Band0, Band1 for RXB 
##							[2500,2500],        	#Band0, Band1 for RXC 
##							[1800,1800]]        	#Band0, Band1 for RXD

		#####	FB	#####
sysParams.fbEnable = [False,False]
sysParams.ddcFactorFb	=	[12,12]					#DDC decimation factor for FB 1 and 2
sysParams.fbNco0		= 	[2000,2000]				#Band0 for FB1 and FB2 

		#####	TX	#####
sysParams.txEnable = [False,False,False,False]
sysParams.ducFactorTx	=	[18,18,18,18]			#DDC decimation factor for TX A, B, C and D
sysParams.txNco0		= 	[[2000,2000],			#Band0, Band1 for TXA 
							[2000,2000],        	#Band0, Band1 for TXB 
							[2000,2000],        	#Band0, Band1 for TXC 
							[2000,2000]]        	#Band0, Band1 for TXD 


##############		JESD		##############

		#####	ADC-JESD	#####
sysParams.jesdSystemMode= [3,3]
													#SystemMode 0:	2R1F-FDD						; rx1-rx2-fb -fb
													#SystemMode 1:	1R1F-FDD						; rx -rx -fb -fb
													#SystemMode 2:	2R-FDD							; rx1-rx1-rx2-rx2
													#SystemMode 3:	1R								; rx -rx -rx -rx
													#SystemMode 4:	1F								; fb -fb- fb -fb
													#SystemMode 5:	1R1F-TDD						; rx/fb-rx/fb-rx/fb-rx/fb
													
sysParams.jesdTxProtocol= [0,0]						# 0 - 8b/10b encoding; 2 - 64b/66b encoding 
sysParams.LMFSHdRx		= ["12410"]*4
													# The 2nd and 4th are valid only for jesdSystemMode values in (0,2).
													# For other modes, select 4 converter modes for 1st and 3rd.
sysParams.LMFSHdFb		= ["12410","12410"]

sysParams.rxJesdTxScr	= [True,True,True,True]
sysParams.fbJesdTxScr	= [True,True]

sysParams.rxJesdTxK		= [16,16,16,16]
sysParams.fbJesdTxK		= [16,16]

sysParams.rxDataMux		= [0,1,2,3,4,5,6,7]
sysParams.jesdTxLaneMux	= [0,1,2,3,4,5,6,7]			# Enter which lanes you want in each location. 
													# For example, if you want to exchange the first two lines of each 2T,
													#		this should be [[1,0,2,3],[5,4,6,7]]

		#####	DAC-JESD	#####
sysParams.jesdRxProtocol= [0,0]
sysParams.LMFSHdTx		= ["44210","44210","44210","44210"]
sysParams.jesdRxLaneMux	= [0,1,2,3,4,5,6,7]			# Enter which lanes you want in each location.
													# For example, if you want to exchange the first two lines of each 2R
													#		this should be [[1,0,2,3],[5,4,6,7]]
sysParams.jesdRxRbd		= [4, 4]
sysParams.jesdRxScr		= [True,True,True,True]
sysParams.jesdRxK		= [16,16,16,16]

		#####	JESD Common	#####
	
sysParams.jesdABLvdsSync= True
sysParams.jesdCDLvdsSync= True
sysParams.syncLoopBack	= True	#JESD Sync signal is connected to FPGA

##############		GPIO		##############
sysParams.gpioMapping	= {
						'H8': 'ADC_SYNC0',
						'H7': 'ADC_SYNC1',
						'N8': 'ADC_SYNC2',
						'N7': 'ADC_SYNC3',
						'H9': 'DAC_SYNC0',
						'G9': 'DAC_SYNC1',
						'N9': 'DAC_SYNC2',
						'P9': 'DAC_SYNC3',
							'P14': 'GLOBAL_PDN',
						'K14': 'FBABTDD',
						'R6': 'FBCDTDD',
						'H15': ['TXATDD','TXBTDD'],
						'V5': ['TXCTDD','TXDTDD'],
						'E7': ['RXATDD','RXBTDD'],
						'R15': ['RXCTDD','RXDTDD']}

##############		LMK Params		##############
lmkParams.pllEn			= False
lmkParams.inputClk		= 930 # Valid only when lmkParams.pllEn = False
lmkParams.lmkFrefClk	= True
setupParams.fpgaRefClk	= 93 #245.76 # Should be equal to LaneRate/40 for TSW14J56

##############		Logging		##############
logDumpInst.setFileName(ASTERIX_DIR+DEVICES_DIR+r"\Afe79xxPg1.txt")
logDumpInst.logFormat=0x0 #Modify to 0x1 to save register scequence to log file. Script takes more time to execute.
logDumpInst.rewriteFile=1
logDumpInst.rewriteFileFormat4=1
device.optimizeWrites=0
device.rawWriteLogEn=1
lmk.rawWriteLogEn = 1
device.delay_time = 0
#-------------------------------------------------------------------------------------------------#
AFE.deviceBringup()

AFE.TOP.overrideTdd(4,0,0)	# bit-wise; 4R,2F,4T

##lmk.writeReg(352,0x00)
##lmk.writeReg(353,0x02)
##lmk.writeReg(358,0x00)
##lmk.writeReg(359,0x00)
##lmk.writeReg(360,0x19)